part of keyclic_sdk_api.api;

class FeedbackLinksDocument {
  FeedbackLinksDocument({
    this.href,
    this.iriTemplate,
  });

  factory FeedbackLinksDocument.fromJson(Map<String, dynamic> json) {
    if (json == null) {
      return null;
    }

    return FeedbackLinksDocument(
      href: json['href'],
      iriTemplate:
          FeedbackLinksDocumentIriTemplate.fromJson(json['iriTemplate']),
    );
  }

  /* The URI of the document associated to the given feedback. */
  String href;

  FeedbackLinksDocumentIriTemplate iriTemplate;

  @override
  bool operator ==(dynamic other) {
    // Same reference
    if (identical(this, other)) {
      return true;
    }

    return other is FeedbackLinksDocument &&
        runtimeType == other.runtimeType &&
        href == other.href &&
        iriTemplate == other.iriTemplate;
  }

  /// By default hashCode return reference
  @override
  int get hashCode {
    int hashCode = 0;

    hashCode ^= href?.hashCode ?? 0;
    hashCode ^= iriTemplate?.hashCode ?? 0;

    return hashCode;
  }

  static List<FeedbackLinksDocument> listFromJson(List<dynamic> json) {
    return json
            ?.map((dynamic value) => FeedbackLinksDocument.fromJson(value))
            ?.toList() ??
        <FeedbackLinksDocument>[];
  }

  static Map<String, FeedbackLinksDocument> mapFromJson(
      Map<String, dynamic> json) {
    return json
            ?.map<String, FeedbackLinksDocument>((String key, dynamic value) {
          return MapEntry(key, FeedbackLinksDocument.fromJson(value));
        }) ??
        <String, FeedbackLinksDocument>{};
  }

  Map<String, dynamic> toJson() {
    return {
      if (href != null) 'href': href,
      if (iriTemplate != null) 'iriTemplate': iriTemplate.toJson(),
    };
  }

  @override
  String toString() {
    return 'FeedbackLinksDocument[href=$href, iriTemplate=$iriTemplate, ]';
  }
}
